using System;
using System.Drawing;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools; 


namespace ComboGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
        private System.ComponentModel.Container components = null;

		

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            
            
             

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
            ((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridDataBoundGrid1
            // 
            this.gridDataBoundGrid1.AllowDragSelectedCols = true;
            this.gridDataBoundGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridDataBoundGrid1.Location = new System.Drawing.Point(0, 0);
            this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
            this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
            this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
            this.gridDataBoundGrid1.Size = new System.Drawing.Size(704, 278);
            this.gridDataBoundGrid1.SmartSizeBox = false;
            this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
            this.gridDataBoundGrid1.TabIndex = 0;
            this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
            this.gridDataBoundGrid1.UseListChangedEvent = true;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(704, 278);
            this.Controls.Add(this.gridDataBoundGrid1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		
		private void Form1_Load(object sender, System.EventArgs e)
		{
            sToolTip = new SuperToolTip(this);
            DataTable dt = GetParentTable();
			this.gridDataBoundGrid1.DataSource = dt;
           
            this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(Model_QueryCellInfo);
            this.gridDataBoundGrid1.ActivateToolTip += new GridActivateToolTipEventHandler(gridDataBoundGrid1_ActivateToolTip);  
		}

        void Model_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
        {
            e.Style.CellTipText = "ToolTip Text"; 
        }

        private SuperToolTip sToolTip ;        
        void gridDataBoundGrid1_ActivateToolTip(object sender, GridActivateToolTipEventArgs e)
        {
            e.Cancel = true;
            ToolTipInfo tipInfo = new ToolTipInfo();
            tipInfo.BackColor = Color.Red;
            tipInfo.Body.Image = SystemIcons.Information.ToBitmap();
            tipInfo.Body.Text = e.Style.CellTipText +":::" + e.Style.Text ;

            int width = tipInfo.Body.GetPreferredSize(int.MaxValue,true).Width;

            if (MousePosition.X + width < this.Location.X + this.gridDataBoundGrid1.Size.Width)
            {
                sToolTip.Show(tipInfo, new Point(MousePosition.X + 15, MousePosition.Y));
            }
            else
            {
                Point pt = new Point(MousePosition.X - width, MousePosition.Y);   
                sToolTip.Show(tipInfo, pt);
            }

        }

		#region DataTables

		private int numberParentRows = 12;
		private int numberChildRows = 20;
		
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("EmpNo"));
			dt.Columns.Add(new DataColumn("EmpName" ));
			dt.Columns.Add(new DataColumn("DeptNo"));
			dt.Columns.Add(new DataColumn("Salary" ,typeof(int)));

			for(int i = 0;i< 5;i++)
			dt.Columns.Add(new DataColumn("Column" + i));
			
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = "EmployeeNumber" + i; 
				dr[1] = "EmpName" + i; 
				dr[2] = "DeptNo" + i; 
				dr[3] = 1000 * 10 * i; 
				dt.Rows.Add(dr);
			}
		 


			return dt;
		}

				
		#endregion
        
	}
}
